<?php
include('/usr/fallback/beroConf.php');
include('/usr/local/php/include/fulltrace.Class.php');

/**
 * Klasse Fulltrace
 */

class FulltraceGui {

	private $_ba;
	private $_bc;
	private $_ft;

	function __construct () {
		$this->_ba = new beroAri();
		$this->_bc = new beroConf('root');
		$this->_ft = new fulltrace();
	}

	// Die Funktion ports wird benutzt um alle ISDN Ports anzuzeigen.
	function show_isdn_ports () {
		$qu = $this->_ba->select('SELECT * FROM isdn');
		while ($entry = $this->_ba->fetch_array($qu)) {
			// Für jeden Port wird ein checkbox erzeugt
			$select .= '<input type="checkbox" name="ports[]" value="' . $entry['port'] . '" checked /><label for="ports[]">' . $entry['port'] . "</label>\n";
		}

		return($select);
	}

	private function _show_trace_run () {

		$ret =	'<br /><form method="POST">' .
			'<table class="table table-striped table-bordered" style="max-width: 520px; margin:auto;">' .
			'<tr><th colspan="2">' . FULL_TRACE_TABLE_HEADER_DIS . '</th></tr>' .
			'<tr><td><img src="includes/images/punkt_gruen.gif" /></td>' .
			'<td>' .
			'<input type="submit" class="btn btn-default" id="trace" name="trace" onmouseover="Tip(\'' . DEBUG_STOP_TRACE . '\')" onmouseout="UnTip()" value="Stop" />' .
			'</td></tr>' .
			'</table> ' .
			'</form><br />';

		// we don't display file-download during trace if we're not 'advanced'
		if (((strlen($this->_ba->get('gui_mode')) == 0) ? 'easy' : $this->_ba->get('gui_mode')) != 'advanced') {
			return($ret);
		}

		$ret .= '<table class="table table-striped table-bordered" style="max-width: 520px; margin:auto;">' .
			'<tr><th colspan="2">Single File Download</th></tr>';

		foreach ($this->_ft->get_runtime_files() as $ftFile) {
			if (empty($ftFile)) {
				continue;
			}
			$ret .= '<tr><td>' . basename($ftFile) . '</td>' .
				'<td>' .
				'<form name="download_logfile" action="modules/FulltraceGui/isdn_trace.php?option=single_logfile" method="POST">' .
				'<input type="hidden" name="logfile_name" value="' . basename($ftFile) . '" />' .
				'<input type="submit" class="btn btn-default" value="Download" />' .
				'</form>' .
				'</td></tr>';
		}
		$ret .= '</table>'
			. '<br />';

		return($ret);
	}

	function table() {

		$colspan = 2;
		unset($th);
		unset($td);

		$query_gsm = $this->_ba->select('SELECT * FROM gsm');
		if (sqlite_num_rows($query_gsm) > 0) {
			$colspan++;
			$th .= "<td>GSM</td>";
			$td .= "<td><input type='checkbox' value='1' name='gsm' id='gsm' checked>"
				. "<label for='gsm'>" . FULL_TRACE_ENABLE_DIS . "</label></td>";
			$colspan++;
			$th .= "<td>GSM SMS</td>";
			$td .= "<td><input type='checkbox' value='1' name='gsm_sms' id='gsm_sms'>"
				. "<label for='gsm_sms'>" . FULL_TRACE_ENABLE_DIS . "</label></td>";
		}

		$query_analog = $this->_ba->select('SELECT * FROM analog');
		if (sqlite_num_rows($query_analog) > 0) {
			$colspan++;
			$th .= "<td>ANALOG</td>";
			$td .= "<td><input type='checkbox' value='1' name='analog' id='analog' checked><label for='analog'>" . FULL_TRACE_ENABLE_DIS . "</label></td>";
		}

		$query_analog = $this->_ba->select('SELECT * FROM cas WHERE port_type = \'cas=\'');
		if (sqlite_num_rows($query_analog) > 0) {
			$colspan++;
			$th.="<td>CAS</td>";
			$td.="<td><input type='checkbox' value='1' name='cas' id='cas'  checked><label for='analog'>" . FULL_TRACE_ENABLE_DIS . "</label></td>";
		}

		$interface =	'<input type="checkbox" name="localhost" id="localhost" value="1" checked /><label for="localhost">lo</label>' .
				'<input type="checkbox" name="lan" id="lan" value="1" checked /><label for="lan">lan</label>';

		$sip_audio =	'<input type="checkbox" name="any" id="any" value="1" />'
			. '<label for="any">' . FULL_TRACE_ANY_TRAFFIC_DIS . '</label><br>'
			. '<input type="checkbox" name="sip_sign" id="sip_sign" value="1" onclick="if (sip_sign.checked==true) sip_audio.disabled=false; else sip_audio.disabled=true;" checked/>'
			. '<label for="sip_sign">SIP signaling</label><br>'
			. '<input type="checkbox" name="rtp_udptl" id="rtp_udptl" value="1" />'
			. '<label for="rtp_udptl">RTP/UDPTL</label>';
		$syslog = "<input type='checkbox' name='syslog' id='syslog' value='1' /><label for='syslog'>syslog</label>";
		return "<br/><form method='POST'>
			<table class='table table-striped table-bordered' id='table' style='max-width:520px; margin:auto;'>
			<tr><th colspan='$colspan' class='text-center'>" . FULL_TRACE_TABLE_HEADER_DIS . "</th></tr>
			<tr>
			<td>" . FULL_TRACE_ISDN_PORTS_DIS . "</td><td>" . FULL_TRACE_NETWORK_DIS . "</td>$th
			</tr>
			<tr>
			<td nowrap>
			<input type='checkbox' name='isdn_enable' id='isdn_enable' value='1' onclick='dis();' checked/>
			<label for='isdn_enable'>" . FULL_TRACE_ENABLE_DIS . "</label>
			<br/>
			<b>" . FULL_TRACE_CHECK_ALL_DIS . "</b>
			<input type='checkbox' id='checkall' name='checkall' onclick='checkallp();' onmouseover=\"Tip('" . DEBUG_CHECK_ALL . "')\" onmouseout='UnTip()'>
			<br/>" .
			$this->show_isdn_ports() .
			"<br/>
			<br/>
			</td>
			<td>
			<fieldset>
			$sip_audio
			<br/>
			$syslog
			<br/>
			<b>Interface</b>
			<br/>
			$interface
			</fieldset>
			</td>
			$td
			</tr>
			<tr>
			<td colspan='$colspan' class='text-center'>
			<img src='./includes/images/punkt_rot.gif'>&nbsp;&nbsp;&nbsp;
			<input type='submit' class='btn btn-default' id='trace' name='trace' onmouseover=\"Tip('" . DEBUG_START_TRACE . "')\" onmouseout='UnTip()' value='" . FULL_TRACE_BUTTON_START_DIS . "'>
			</td>
			</tr>
			</table>
			</form><br/>";

	}

	function display() {

		$name = 'FULL_TRACE_TITLE_DIS';
		include('./includes/header.php');
		require_once('./includes/isgwtelnet.php');

		// actually js belongs into a separate file...
			$ret .=	'<script language="javascript">' . "\n" .
			'function checkallp () {' . "\n" .
			'var checkall = document.getElementById(\'checkall\');' . "\n" .
			'var del = document.getElementsByName(\'ports[]\');' . "\n" .
			'if (checkall.checked == true) {' . "\n" .
			'for (i = 0; i < del.length; i++) {' . "\n" .
			'del[i].checked=true;' . "\n" .
			'}' . "\n" .
			'} else {' . "\n" .
			'for (i = 0; i < del.length; i++) {' . "\n" .
			'del[i].checked = false;' . "\n" .
			'}' . "\n" .
			'}' . "\n" .
			'}' . "\n\n" .
			'function dis() {' . "\n" .
			'var isdn_enable = document.getElementById(\'isdn_enable\');' . "\n" .
			'var checkall = document.getElementById(\'checkall\');' . "\n" .
			'var del = document.getElementsByName(\'ports[]\');' . "\n" .
			'if (isdn_enable.checked == true) {' . "\n" .
			'checkall.disabled = false;' . "\n" .
			'for (i = 0; i < del.length; i++) {' . "\n" .
			'del[i].disabled = false;' . "\n" .
			'}' . "\n" .
			'} else {' . "\n" .
			'checkall.disabled = true;' . "\n" .
			'for (i = 0; i < del.length; i++) {' . "\n" .
			'del[i].disabled = true;' . "\n" .
			'}' . "\n" .
			'}' . "\n" .
			'}' . "\n" .
			'</script>';

		switch ($_POST['trace']) {
		case 'Start':
			$enable['isdn'] =	(($_POST['isdn_enable'] == '1') ? 1 : 0);
			$enable['analog'] =	(($_POST['analog'] == '1') ? 1 : 0);
			$enable['gsm'] =	(($_POST['gsm'] == '1') ? 1 : 0);
			$enable['cas'] =	(($_POST['cas'] == '1') ? 1 : 0);
			$enable['sip_sign'] =	(($_POST['sip_sign'] == '1') ? 1 : 0);
			$enable['rtp_udptl'] =	(($_POST['rtp_udptl'] == '1') ? 1 : 0);
			$enable['any'] =	(($_POST['any'] == '1') ? 1 : 0);
			$enable['lan'] =	(($_POST['lan'] == '1') ? 1 : 0);
			$enable['lo'] =		(($_POST['localhost'] == '1') ? 1 : 0);
			$enable['syslog'] =	(($_POST['syslog'] == '1') ? 1 : 0);
			$log_size = (($this->_bc->get('root', 'cifs_log_enabled') == '1') ? $this->_bc->get('root', 'cifs_log_size') : null);
			$this->_ft->start($enable, $_POST['ports'], $log_size);
			unset($enable);
			$ret .= $this->_show_trace_run();
			break;
		case 'Stop':
			$log_date = (($this->_bc->get('root', 'cifs_log_enabled') == '1') ? true : false);
			$this->_ft->stop($log_date);
			$ret .= $this->table();
			break;
		default:
			if ($this->_ba->get('trace') == 'yes') {
				$ret .= $this->_show_trace_run();
				break;
			}
			$ret .= $this->table();
			break;
		}
/*
		if (((strlen($this->_ba->get('trace')) == 0) || ($this->_ba->get('trace') == 'no')) && !isset($_POST['trace'])) {
			$ret .= $this->table();
		} elseif ($_POST['trace'] == 'Start' ) {

		} else if ($_POST['trace'] == 'Stop') {
		} else if ($this->_ba->get('trace') == 'yes') {
			$ret .= $this->_show_trace_run();
		}
 */
	/*
	 * Überprüfung ob die dateien debug-info.tar.gz oder DebugFiles.tar.gz oder isgw.err,
	 * Wenn ja, wird einen Link für Download angeboten, und einen Link delete
	 * um die entsprechende Datei zu löschen
	 */
	if (file_exists("/var/log/debug-info.tar.gz") || file_exists("/var/log/DebugFiles.tar.gz") || file_exists("/var/log/isgw.err")){
		$ret.="<form method='POST'>
			<table class='table table-striped table-bordered' style='max-width:520px; margin:auto;'>
				<tr><th colspan='2'>".FULL_TRACE_DOWNLOADS_DIS."</th></tr>";
		if (file_exists("/var/log/debug-info.tar.gz"))
		$ret.="<tr>
			<td nowrap style='text-align:left;'><b>".FULL_TRACE_ISGW_COREDUMPS_DIS."</b>&nbsp;&nbsp;
			<input type='button' class='btn btn-default' value='".FULL_TRACE_BUTTON_DOWNLOAD_DIS."' onclick=\" window.location.href='modules/FulltraceGui/isdn_trace.php?option=isgw';\" onmouseover=\"Tip('".DEBUG_DOWNLOAD_TRACE."')\" onmouseout='UnTip()'>&nbsp;&nbsp;
			<input type='button' class='btn btn-default' value='".FULL_TRACE_BUTTON_DELETE_FILE_DIS."' onclick=\"javascript:if (confirm('".FULL_TRACE_DELETE_COREDUMPS_DIS."?')==true) window.location.href='misc/deletefile.php?m=".$_GET['m']."';\" onmouseover=\"Tip('".DEBUG_DELETE."')\" onmouseout='UnTip()'></td>
			<td>".date("d M Y H:i",filectime("/var/log/debug-info.tar.gz"))."</td>
			</tr>";
		if (file_exists("/var/log/DebugFiles.tar.gz"))
		$ret.="<tr>
			<td nowrap style='text-align:left;'><b>".FULL_TRACE_DEBUG_FILES_DIS."</b>&nbsp;&nbsp;
			<input type='button' class='btn btn-default' value='".FULL_TRACE_BUTTON_DOWNLOAD_DIS."' onclick=\" window.location.href='modules/FulltraceGui/isdn_trace.php';\" onmouseover=\"Tip('".DEBUG_DOWNLOAD_TRACE."')\" onmouseout='UnTip()'>&nbsp;&nbsp;
			<input type='button' class='btn btn-default' value='".FULL_TRACE_BUTTON_DELETE_FILE_DIS."' onclick=\"javascript:if (confirm('".FULL_TRACE_DELETE_DEBUG_FILES_DIS."?')==true) window.location.href='misc/deletefile.php?m=".$_GET['m']."&option=debug';\" onmouseover=\"Tip('".DEBUG_DELETE_FILES."')\" onmouseout='UnTip()'>
			<td>".date("d M Y H:i",filectime("/var/log/DebugFiles.tar.gz"))."</td>
			</tr>";
		if (file_exists("/var/log/isgw.err"))
		$ret.="<tr>
			<td nowrap style='text-align:left;'><b>".FULL_TRACE_ERROR_LOG_DIS."</b>&nbsp;&nbsp;
			<input type='button' class='btn btn-default' value='".FULL_TRACE_BUTTON_DOWNLOAD_DIS."' onclick=\" window.location.href='modules/FulltraceGui/isdn_trace.php?option=error';\" >&nbsp;&nbsp;
			<td>".date("d M Y H:i",filectime("/var/log/isgw.err"))."</td>
			</tr>";
		if (file_exists("/var/log/cloud.log"))
		$ret.="<tr>
			<td nowrap style='text-align:left;'><b>".FULL_TRACE_CLOUD_LOG_DIS."</b>&nbsp;&nbsp;
			<input type='button' class='btn btn-default' value='".FULL_TRACE_BUTTON_DOWNLOAD_DIS."' onclick=\" window.location.href='modules/FulltraceGui/isdn_trace.php?option=cloud';\" >&nbsp;&nbsp;
			<td>".date("d M Y H:i",filectime("/var/log/cloud.log"))."</td>
			</tr>";
		$ret.="</table>"
			. "</form><br/>";
	}


	//Rückgabe: Der Inhalt von der HTML-Seite
	return $ret;
}
}
?>
